<script>
import Vue from "vue";
import { SlpContainer, SlpRow, SlpColumn, SlpTypography } from "slippers-ui";
import { getPageAvailableLanguages } from "@/services/language.service";

import LanguageSelector from "@/components/Common/language-selector.vue";
import GitLabIcon from "../../assets/gitlab.vue";

import data from "./minimal-footer.json";

export default Vue.extend({
  name: "SlpMinimizedFooter",
  components: {
    SlpContainer,
    SlpRow,
    SlpColumn,
    SlpTypography,
    GitLabIcon,
    LanguageSelector,
  },
  props: {
    contentfulFooterData: {
      type: Object,
      required: true,
    },
    contentfulEntryUrl: {
      type: String,
      required: false,
    },
  },
  data() {
    return {
      content: data,
      currentYear: new Date().getFullYear(),
      isHandbook: false,
      availableLanguages: [],
    };
  },
  async beforeMount() {
    this.content = this.formatCtfFooterData(this.contentfulFooterData);
    await this.shouldLocalizeNav();
  },
  mounted() {
    this.isHandbook = window.location.href.includes("/handbook");
  },
  methods: {
    async shouldLocalizeNav() {
      this.availableLanguages = await getPageAvailableLanguages(
        window.location.origin,
        window.location.pathname
      );
    },
    emitOneTrustEvent() {
      let clickEvent = new Event("oneTrustShowSettings", { bubbles: true });
      document.dispatchEvent(clickEvent);
    },
    formatCtfFooterData(ctfData) {
      const columns = ctfData.fields.columns.map((column) => ({
        ...column.fields,
        links: column.fields.links.map((link) => link.fields),
        subMenu: (column.fields.subMenu || []).map((menu) => ({
          ...menu.fields,
          links: menu.fields.links.map((link) => link.fields),
        })),
      }));
      let minimalFooterLinks = [];
      for (const column of columns) {
        for (const link of column.links) {
          if (link.includeOnMinimizedFooter) {
            minimalFooterLinks.push(link);
          }
        }
      }
      return {
        ...ctfData.fields,
        minimalFooterLinks,
      };
    },
  },
});
</script>

<template>
  <footer id="be-min-footer" class="be-nav-minimal-footer">
    <SlpContainer>
      <SlpRow>
        <SlpColumn class="be-nav-minimal-footer__navigation">
          <SlpColumn :cols="2" class="logo">
            <GitLabIcon />
          </SlpColumn>
          <SlpColumn :cols="10" class="links_container">
            <SlpRow>
              <ul class="content">
                <li
                  v-for="link in content.minimalFooterLinks"
                  :key="link.internalName"
                  class="column links__item"
                >
                  <button
                    v-if="link.isOneTrustButton"
                    :id="link.id"
                    class="ot-sdk-show-settings"
                    @click="emitOneTrustEvent()"
                  >
                    {{ link.text }}
                  </button>
                  <a
                    v-else
                    :href="link.href"
                    class="link"
                    :data-ga-name="link.text"
                    data-ga-location="footer"
                  >
                    {{ link.text }}
                  </a>
                </li>
              </ul>
            </SlpRow>
            <SlpRow>
              <SlpColumn :cols="12">
                <LanguageSelector
                  class="selector"
                  v-if="availableLanguages.length"
                  :available-languages="availableLanguages"
                />
              </SlpColumn>
            </SlpRow>
            <SlpRow class="lower_content">
              <SlpColumn :cols="12" class="footer__cta">
                <div class="source">
                  <SlpTypography tag="p">
                    {{ content.text }}
                  </SlpTypography>
                  <p class="be-nav-footer__button-container">
                    <a
                      target="_blank"
                      class="be-nav-footer__button"
                      href="https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience"
                      data-ga-name="page source"
                      data-ga-location="footer"
                    >
                      {{ content.sourceCtaText }}
                    </a>

                    <a
                      v-if="contentfulEntryUrl"
                      target="_blank"
                      class="be-nav-footer__button"
                      :href="contentfulEntryUrl"
                      data-ga-name="web ide"
                      data-ga-location="footer"
                    >
                      {{ content.editCtaText }}
                    </a>

                    <a
                      href="https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience/-/blob/main/CONTRIBUTING.md"
                      data-ga-name="please contribute"
                      data-ga-location="footer"
                      >{{ content.contributeCtaText }}</a
                    >

                    <span v-if="isHandbook" class="cc-license">
                      <a
                        rel="license"
                        href="http://creativecommons.org/licenses/by-sa/4.0/"
                        ><img
                          alt="Creative Commons License"
                          style="border-width: 0"
                          src="https://i.creativecommons.org/l/by-sa/4.0/80x15.png"
                      /></a>
                    </span>
                  </p>
                  <p>&copy; {{ currentYear }} GitLab Inc.</p>
                </div>
              </SlpColumn>
            </SlpRow>
          </SlpColumn>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </footer>
</template>

<style lang="scss">
.be-nav-minimal-footer {
  background-color: $color-surface-700;
  color: $color-text-50;
  padding: 40px $spacing-16;

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  a:not(.slp-btn) {
    text-decoration: none;
    color: $color-text-50;
  }

  p > a:not(.slp-btn),
  li a:not(.slp-btn) {
    color: $color-text-50;

    &:hover {
      text-decoration: underline;
    }
  }

  &__navigation {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    flex-wrap: wrap;
    flex-direction: column;
  }

  .logo {
    margin: $spacing-48 auto 0 0;
    display: flex;
    box-sizing: border-box;
  }



  .content {
    display: flex;
    width: 100%;
    align-items: center;
    margin-top: $spacing-48;
    flex-wrap: wrap;

    @media (max-width: $breakpoint-md) {
      gap: 30px;
    }
    @media (max-width: $breakpoint-sm) {
      gap: 8px;
      margin-bottom:0;
    }
  }

  .column {
    flex: auto;
  }

  .links {
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    flex-wrap: wrap;
    &__item {
      margin-bottom: $spacing-8;
      display: flex;
      align-items: center;
      @media (max-width: $breakpoint-sm) {
        display:inline;
        display: block;
        width: 100%;
      }
    }

  }

  .link {
    font-size: $text-body-2;
    color: $color-text-50;
    padding:6px;
    @media (max-width: $breakpoint-sm) {
      padding-left: 0px;

    }
  }

  .social__links--icon {
    width: 24px;
    height: auto;
    color: $color-text-50;
    transition: 0.3s;

    &:hover {
      color: $color-accent-400;
    }
  }

  .lower_content {
    display: flex;
  }
  .footer__cta {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
    align-items: flex-start;
    padding-top: $spacing-8;
    width: 100%;
  }

  .selector {
    padding: 16px 0;
  }

  .source {
    width: 100%;
    margin-right: $spacing-8;

    .be-nav-footer__button-container {
      display: flex;
      flex-wrap: wrap;
      gap: 8px 24px;
    }

    p {
      margin-bottom: $spacing-8;
      font-size: $text-body-3;
    }

    a {
      font-weight: $font-weight-bold;
      color: $color-text-50;
      text-decoration: underline;
    }

    img {
      display: inline-block;
      vertical-align: middle;
      margin-left: 5px;
    }

    button {
      color: $color-text-50;
      text-decoration: underline;
      border: none;
      padding: 0;
      cursor: pointer;
      font-weight: $font-weight-bold;
      font-size: $text-body-3;
    }
  }
  .social__links {
    display: flex;
    justify-content: center;
  }
  .social__links--list {
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 15px;
    margin-bottom: $spacing-16;
  }

  // OneTrust button in footer
  #ot-sdk-btn.ot-sdk-show-settings,
  #ot-sdk-btn.optanon-show-settings {
    color: $color-text-50 !important;
    border: 0 !important;
    border: none !important;
    padding-right: $spacing-48 !important;
    font-size: 16px !important;
    font-family: "GitLab Sans", sans-serif !important;
    text-align: left !important;

    &:hover {
      text-decoration: underline;
      background: inherit;
    }

    @media (max-width: $breakpoint-sm) {
      padding-left:0;
    }
  }
}

@media (min-width: $breakpoint-md) {
  .be-nav-minimal-footer {
    .footer__cta {
      align-items: center;
    }

    .social__links {
      margin-top: 0;
      width: inherit;
    }
    .links_container {
      padding-left:40px;
    }
  }
}


</style>
